﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace UrlEnDe
{
    public partial class frmmain : Form
    {
        public frmmain()
        {
            InitializeComponent();
        }

        private bool isVaildChars(char c)
        {
            bool _vaild = false;

            if (char.IsLetterOrDigit(c))
            {
                return true;
            }
            
            switch (c)
            {
                case '(':
                case ')':
                case '-':
                case '*':
                case ',':
                case '_':
                case '~':
                case '.':
                case '!':
                    _vaild = true;
                    break;
                default:
                    _vaild = false;
                    break;
            }
            return _vaild;
        }

        private string DecodeString(string src)
        {
            int I = 0;
            string sHex = string.Empty;
            string buff = string.Empty;
            char c = '\0';

            while (I < src.Length)
            {
                //Fetch char.
                c = src[I];

                //Check for hex.
                if (c == '%')
                {
                    //Decode hex value.
                    I++;
                    //Extract hex
                    try
                    {
                        sHex = src[I].ToString() + src[I + 1].ToString();
                    }
                    catch
                    {
                        sHex = string.Empty;
                    }
                    //Check for length of hex value must be 2
                    if (sHex.Length == 2)
                    {
                        try
                        {
                            //Convert hex to char.
                            c = (char)int.Parse(sHex, System.Globalization.NumberStyles.HexNumber);
                            //INC Counter.
                            I += 1;
                        }
                        catch
                        {
                            break;
                        }
                    }
                }
                //Build buffer.
                buff += c.ToString();
                //INC Counter.
                I++;
            }
            //Return string.
            return buff;
        }

        private string EncodeString(string src)
        {
            int I = 0;
            int cAsc = 0;
            string buff = string.Empty;

            while (I < src.Length)
            {
                //Get char code.
                cAsc = (int)src[I];

                //Check for vaild chars.
                if (isVaildChars(src[I]))
                {
                    //Build buffer.
                    buff += (char)cAsc;
                }
                else
                {
                    //Check we not hit a new line.
                    if (src[I] != '\n')
                    {
                        //Append hex value.
                        buff += "%" + cAsc.ToString("X2");
                    }
                }
                //INC Counter.
                I++;
            }
            //Return string.
            return buff;
        }

        private void cmdEncode_Click(object sender, EventArgs e)
        {
            txtEncode.Text = EncodeString(textBox1.Text);
            txtDecode.Text = DecodeString(txtEncode.Text);
        }

        private void cmdExit_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
